Debian Bug report logs - #526617
dpkg: mentions arch:any in dsc way too often

version graph

Package: dpkg; Maintainer for dpkg is Dpkg Developers <debian-dpkg@lists.debian.org>; Source for dpkg is src:dpkg.

Reported by: Philipp Kern <pkern@debian.org>

Date: Sat, 2 May 2009 10:09:54 UTC

Severity: important

Tags: patch

Found in version dpkg/1.14.25

Fixed in version dpkg/1.15.1

Done: Guillem Jover <guillem@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, wb-team@buildd.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#526617; Package dpkg. (Sat, 02 May 2009 10:09:56 GMT) Full text and rfc822 format available.

Message #3 received at submit@bugs.debian.org (full text, mbox):

From: Philipp Kern <pkern@debian.org>
To: submit@bugs.debian.org
Subject: dpkg: mentions arch:any in dsc way too often
Date: Sat, 2 May 2009 11:49:14 +0200
[Message part 1 (text/plain, inline)]
Package: dpkg
Version: 1.14.25
Severity: important
Tags: patch

Let's assume a package with the following debian/control (Descriptions and
Dependencies scrubbed):

[Source part]

Package: ia32-libs-tools
Architecture: i386 amd64 ia64

Package: ia32-archive
Architecture: all

Package: ia32-apt-get
Architecture: amd64 ia64

In this case dpkg-source will put arch:any into the dsc despite the
fact that no binary package (except the arch:all) will be buildable
on architectures apart from i386, amd64 and ia64.  This led to the
introduction of Packages-arch-specific ten years ago.

The attached patch will generate "all i386 amd64 ia64" instead.
I haven't found something in policy that contradicts this.  Currently
I resort to generate this information on ftp-master.  It would be
very helpful to let dpkg-source generate it properly.

Kind regards,
Philipp Kern
-- 
 .''`.  Philipp Kern                        Debian Developer
: :' :  http://philkern.de                         Stable Release Manager
`. `'   xmpp:phil@0x539.de                         Wanna-Build Admin
  `-    finger pkern/key@db.debian.org
[0001-dpkg-source-do-not-set-arch-any-in-dsc-on-arch-rest.patch (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Tags added: pending Request was from Guillem Jover <guillem@debian.org> to control@bugs.debian.org. (Sat, 02 May 2009 13:09:04 GMT) Full text and rfc822 format available.

Message sent on to Philipp Kern <pkern@debian.org>:
Bug#526617. (Sat, 02 May 2009 13:09:06 GMT) Full text and rfc822 format available.

Message #8 received at 526617-submitter@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: 526617-submitter@bugs.debian.org
Subject: Bug#526617 marked as pending
Date: Sat, 02 May 2009 13:08:20 +0000
tag 526617 pending
thanks

Hello,

Bug #526617 reported by you has been fixed in the Git repository. You can
see the changelog below, and you can check the diff of the fix at:

    http://git.debian.org/?p=dpkg/dpkg.git;a=commitdiff;h=3624a4b

---
commit 3624a4b0eb5499f367c1d8077240f151903cd70a
Author: Philipp Kern <pkern@debian.org>
Date:   Sat May 2 11:39:00 2009 +0200

    dpkg-source: do not set arch:any in dsc on arch-restricted packages
    
    dpkg-source was pretty liberal in setting 'Architecture: any' in the
    dsc: as soon as there are two binary packages, one being arch:all and
    one being arch-restricted, you get arch:any in the dsc. This is
    incorrect because the package will only build on the autobuilders
    if there are architecture-dependent binary packages available.
    
    Thus this patch only produces arch:any if at least one binary package
    specifies it. Otherwise it outputs the set of all binary architectures
    (including arch:all).
    
    Closes: #526617
    
    Signed-off-by: Philipp Kern <pkern@debian.org>

diff --git a/debian/changelog b/debian/changelog
index 1fc1546..1c88a38 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -72,6 +72,8 @@ dpkg (1.15.1) UNRELEASED; urgency=low
     - Add kfreebsd-i386 and kfreebsd-amd64.
   * Add avr32 to cputable. Closes: #523456
   * Detect the curses headers to use instead of hardcoding them.
+  * Make dpkg-source do not set arch:any in .dsc on arch-restricted packages.
+    Thanks to Philipp Kern <pkern@debian.org>. Closes: #526617
 
   [ Frank Lichtenheld ]
   * Dpkg::Version: Remove unnecessary function next_elem which just




Reply sent to Guillem Jover <guillem@debian.org>:
You have taken responsibility. (Thu, 21 May 2009 05:46:22 GMT) Full text and rfc822 format available.

Notification sent to Philipp Kern <pkern@debian.org>:
Bug acknowledged by developer. (Thu, 21 May 2009 05:46:22 GMT) Full text and rfc822 format available.

Message #13 received at 526617-close@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: 526617-close@bugs.debian.org
Subject: Bug#526617: fixed in dpkg 1.15.1
Date: Thu, 21 May 2009 05:32:08 +0000
Source: dpkg
Source-Version: 1.15.1

We believe that the bug you reported is fixed in the latest version of
dpkg, which is due to be installed in the Debian FTP archive:

dpkg-dev_1.15.1_all.deb
  to pool/main/d/dpkg/dpkg-dev_1.15.1_all.deb
dpkg_1.15.1.dsc
  to pool/main/d/dpkg/dpkg_1.15.1.dsc
dpkg_1.15.1.tar.gz
  to pool/main/d/dpkg/dpkg_1.15.1.tar.gz
dpkg_1.15.1_amd64.deb
  to pool/main/d/dpkg/dpkg_1.15.1_amd64.deb
dselect_1.15.1_amd64.deb
  to pool/main/d/dpkg/dselect_1.15.1_amd64.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 526617@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Guillem Jover <guillem@debian.org> (supplier of updated dpkg package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Thu, 21 May 2009 06:45:45 +0200
Source: dpkg
Binary: dpkg dpkg-dev dselect
Architecture: source amd64 all
Version: 1.15.1
Distribution: unstable
Urgency: low
Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Changed-By: Guillem Jover <guillem@debian.org>
Description: 
 dpkg       - Debian package management system
 dpkg-dev   - Debian package development tools
 dselect    - Debian package management front-end
Closes: 293163 304404 353015 353040 386197 440841 468106 472942 475916 477638 489238 490929 494883 498380 498734 499088 510282 510615 515540 518453 518687 519082 519084 519128 519478 519717 519813 519998 522032 522787 523023 523184 523329 523456 524375 524376 525834 525835 525854 525858 526132 526538 526617 526659 528171
Changes: 
 dpkg (1.15.1) unstable; urgency=low
 .
   [ Raphael Hertzog ]
   * Fix dpkg-genchanges to not include the additional upstream tarballs
     when they are not desired (specific to source packages using format 3.0
     quilt).
   * Call quilt only once to apply all patches instead of once per patch
     when building 3.0 (quilt) source packages. Closes: #518453
   * Fix dpkg-shlibdeps so that it works again when analyzing binaries
     outside of package's directory. Closes: #518687
   * Modify dpkg-shlibdeps to let shlibs.local override symbols files too.
   * Drop support of debian/control's “Format” field used by dpkg-source while
     it's not too late. Instead debian/source/format should be used to indicate
     the desired source package format.
   * Update deb-triggers(5) and dpkg-trigger(1) to add a reference to
     /usr/share/doc/dpkg/triggers.txt.gz. Closes: #519717
   * Avoid perl warnings in dpkg-gencontrol and dpkg-genchanges when the
     Architecture field is missing in a binary package. Closes: #510282
   * Modify Dpkg::Version::check_version() to not die by default.
     Closes: #510615
   * dpkg-source now ignores all possible vi swap file extensions (and not
     only .swp). The corresponding exclude pattern for -I also got tightened to
     only catch filenames starting with a dot. Closes: #515540
   * dpkg-gencontrol displays a better error message when an ORed dependency
     is used in a union field like Conflicts, Replaces or Breaks.
     Closes: #489238
   * dpkg-source's signature check is now done with gpgv if possible and
     timeouts if not completed within 10 seconds. Closes: #490929
     When using gpg, use --no-default-keyring to be consistent with gpgv's
     behaviour to not use the user's keyring. Closes: #440841
   * Update dpkg-dev dependencies: Closes: #472942
     - Move gnupg to Recommends. It's needed to sign .dsc and .changes.
     - Add gpgv to Recommends. Useful to check signatures of extracted packages.
     - Add debian-maintainers to Suggests. Together with debian-keyring they
     contain all the GPG keys required to verify official Debian packages.
   * Drop /etc/dpkg/origins as it's taken over by base-files (see #487437).
   * Fix dpkg-shlibdeps to properly initialize a symbol-based dependency
     even when some symbols are associated with a (fake) version "0". Such a
     version means that the symbol has always existed in all versions of the
     package.
   * When dpkg delegates to dpkg-query or dpkg-deb to do the actual work, add
     the "--" marker to explicitely document the end of options so that
     arguments starting with a dash are not interpreted as options.
     Closes: #293163
     Thanks to Bill Allombert for the patch.
   * dpkg now correctly refuses empty parameters when an integer value is
     wanted. Closes: #386197 Based on a patch by Bill Allombert.
   * Fix a mistake in the french translation of dpkg's manual page.
     Thanks to Jonathan Gibert. Closes: #522032
   * Fix dpkg-source to not die when uncompressor processes are killed by
     SIGPIPE due to tar closing the pipe without exhausting all the data
     available. Closes: #523329
   * dpkg-gencontrol now handles properly (empty) dependencies which contain
     only spaces. Closes: #522787
   * dpkg-source now accepts additional tarballs (in format "3.0 (quilt)")
     with a "component" name containing dashes. Closes: #524376
   * Fix dpkg-source to not complain on binary files that are ignored and are
     not going to be included in the debian tarball of a "3.0 (quilt)" source
     package. Closes: #524375
   * Bump Standards-Version to 3.8.1 (no change required).
   * Do not store usernames and group names in tarballs created by dpkg-source,
     they are anyway ignored at unpack time. Closes: #523184
   * Fix update-alternatives to not remove real files installed in place of
     an alternative link when the corresponding alternative is fully removed.
     Closes: #526538
   * Add a new dpkg-vendor tool to query vendor information stored in
     /etc/dpkg/origins. It can be used in debian/rules to enable different
     behaviour depending on the current vendor at the time of the build.
     Closes: #498380
     Modify dpkg-buildpackage to not set the DEB_VENDOR environment variable,
     packages should use the dpkg-vendor program instead.
   * Ensure that the automatic patch created in format "3.0 (quilt)" is always
     well registered with quilt even when it's updated by a new call to
     dpkg-source. Thanks to Goswin von Brederlow for the initial patch.
     Closes: #525858
   * Do not update/create debian/patches/.dpkg-source-applied during build,
     it's only meant to document what patches have been applied at extraction
     time. Closes: #525835
   * Let dpkg-buildpackage add the missing execute right on debian/rules if
     needed. Display a warning when it happens. Closes: #499088
   * Allow to combine -nc and -S in dpkg-buildpackage but display a warning
     saying that it's not advised. Closes: #304404
   * Let dpkg-buildpackage error out with subprocerr() when dpkg-checkbuilddeps
     is interrupted/killed by a signal. Closes: #498734
   * Fix dpkg-buildpackage/dpkg-genchanges to properly interpret option -v0.
     Closes: #475916
   * Improves how dpkg-parsechangelog handles non-existing versions
     in its --since, --until, --to, --from options. Approximate the intent
     by selectioning the nearest version instead. Closes: #477638
   * Update dpkg-parsechangelog's documentation to make it clearer that spaces
     are not allowed between single characters options and their values.
     Closes: #494883
   * Don't let dpkg-scanpackages complain about missing overrides when
     no overrides file has been given. Closes: #468106
     Thanks to Piotr Engelking for the patch.
 .
   [ Guillem Jover ]
   * Fix typo in dpkg output (‘unexecpted’ → ‘unexpected’). Closes: #519082
     Thanks to Ivan Masár.
   * Sync archtable with architectures currently present in Debian sid.
     - Remove m68k.
     - Add kfreebsd-i386 and kfreebsd-amd64.
   * Add avr32 to cputable. Closes: #523456
   * Detect the curses headers to use instead of hardcoding them.
   * Make dpkg-source do not set arch:any in .dsc on arch-restricted packages.
     Thanks to Philipp Kern <pkern@debian.org>. Closes: #526617
   * Add '.hgtags' to the default dpkg-source -i regex and -I pattern.
     Closes: #525854
   * Use backticks instead of non-portable make $(shell) function in automake.
   * Do not install dselect and start-stop-daemon man pages when the programs
     have been disabled from configure.
   * Move Debian specific keyrings to the Debian vendor class and change the
     Ubuntu vendor class to inherit from it.
   * Do not set the Arch substvar in dpkg-source, avoiding generating warnings
     when there's no compiler present. Closes: #526132
   * Preserve faulting errno when printing reason in start-stop-daemon fatal
     function.
   * Only print fatal errno string in start-stop-daemon if it was non-zero.
   * Print the valid values for the IO scheduler class in start-stop-daemon
     --help output.
   * Print a warning when using obsolete '--print-installation-architecture'.
     Closes: #528171
   * Remove obsolete --largemem and --smallmem dpkg options.
   * Remove obsolete --force-auto-select dpkg option.
   * Remove obsolete priorities support from dpkg.
   * Remove obsolete 822-date program.
   * Do not right justify the database reading progress percent counter.
   * Remove deprecated status on substvars for dpkg-source dpkg-genchanges,
     and stop producing warnings.
   * Make deprecated dpkg-scanpackages --udeb option produce a warning.
   * Change dpkg-source --help output to state there's no default substvar
     file to match reality.
   * Warn in start-stop-daemon if the argument to --name is longer than the
     supported kernel process name size. Closes: #353015, #519128
   * Do not warn in dpkg-deb when parsing unknown fields with the “Private-”
     prefix. Based on a patch by Nils Rennebarth. Closes: #353040
 .
   [ Frank Lichtenheld ]
   * Dpkg::Version: Remove unnecessary function next_elem which just
     replicates the standard shift behaviour.
 .
   [ Colin Watson ]
   * Add "keyrings" vendor hook, used by dpkg-source to allow vendors to
     supply additional keyrings against which source package signatures will
     be verified. Implement this for Ubuntu. Closes: #525834
 .
   [ Updated dselect translations ]
   * German (Sven Joachim).
   * Swedish (Peter Krefting).
 .
   [ Updated scripts translations ]
   * French (Christian Perrier).
   * German (Helge Kreutzmann).
   * Swedish (Peter Krefting).
 .
   [ Added dpkg translations ]
   * Asturian (Marcos Alvarez Costales). Closes: #519478, #519813, #519998
   * Esperanto (Felipe Castro). Closes: #523023
 .
   [ Updated dpkg translations ]
   * French (Christian Perrier).
   * German (Sven Joachim).
   * Slovak (Ivan Masár). Closes: #519084
   * Swedish (Peter Krefting).
   * Russian (Yuri Kozlov). Closes: #526659
 .
   [ Updated man page translations ]
   * German (Helge Kreutzmann).
   * Swedish (Peter Krefting).
Checksums-Sha1: 
 11b656fa6bb519db02fbcc62f9448d78924755bc 1210 dpkg_1.15.1.dsc
 ade2d62e93cc0241d9635209415519092fda8097 7042718 dpkg_1.15.1.tar.gz
 b39bccc1887816ec44c749f1c7171eff605574d1 2182456 dpkg_1.15.1_amd64.deb
 305db33aca055cf5feee2f6ed322a76894864512 667932 dselect_1.15.1_amd64.deb
 a59a21259bf76441f60606547289bc0c38626329 627414 dpkg-dev_1.15.1_all.deb
Checksums-Sha256: 
 f01840f4f58e53ea2773038e2805d3134d6b535ceaaa591c4d3c849262f660ff 1210 dpkg_1.15.1.dsc
 5d88e04046531583e0ecf3e89c9dd8e726ec73af8c37e9c1e334179f9d1f2744 7042718 dpkg_1.15.1.tar.gz
 73e528c12f82ff7105a2f85a48b2415e8c1b253813f3d34eb4edd4a9f914d0d2 2182456 dpkg_1.15.1_amd64.deb
 33061d25579431386df522b528ea0940ae9da404fb4d85cf1969bd4850a3295f 667932 dselect_1.15.1_amd64.deb
 6708a7ab535156547b18ecd05c927dc576215b96f903c45668654d38483ce269 627414 dpkg-dev_1.15.1_all.deb
Files: 
 b57f1a765212f573350dc0c92f94b249 1210 admin required dpkg_1.15.1.dsc
 135338e0a36ae45ff8675006874f4c6c 7042718 admin required dpkg_1.15.1.tar.gz
 86aaa898df539338530b0fcb3e8c62db 2182456 admin required dpkg_1.15.1_amd64.deb
 25f6563787a1e023194c22ffc810d60e 667932 admin optional dselect_1.15.1_amd64.deb
 1b8be073642ccc429f4ebc99a8f31291 627414 utils optional dpkg-dev_1.15.1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iEYEARECAAYFAkoU33gACgkQuW9ciZ2SjJsElgCePY9whxGiB6sVmBNOixSX2nTt
WaAAniCapi6D7zIBzcFv8hrt7AWQQikk
=fkNW
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 23 Jun 2009 07:34:27 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 06:41:32 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.